// File: SumIntFile2.java
// Sum each line and all values in a file of int.
//      The output file contains one integer per line,
//       the sum of the corresponding line of the input file.
//      The last line of the output file (sums.data) contains the sum
//       of all the input file values.
// Here the file input is done by wrapping a FileReader with a
// BufferedReader. This gives us the readLine method to permit
// input of the file line by line

import java.io.*;
import java.util.*;

public class SumIntFile2 {

// Read the input file name from the user
public static String GetInputFile() throws java.io.IOException
{DataInputStream FileNameInput=new DataInputStream(System.in);
 System.out.print("File to Open >");
 System.out.flush();
 return(FileNameInput.readLine());
}

// Read a line from the input file and Sum the ints.
// StringTokenizer allows each token on the line to be extracted.
//      Note that all tokens are strings and are then converted (see
//      the use of the Integer class to accomplish this)       
public static int SumLine(String LineOfInts)
{int Sum=0;
 StringTokenizer IntTokens=new StringTokenizer(LineOfInts);
 while (IntTokens.hasMoreTokens()) {
  Sum+=Integer.valueOf(IntTokens.nextToken()).intValue();
 }
 return(Sum);
}

public static void main(String[] args) throws java.io.IOException
{int SumOfLine,SumOfFile=0;
 // Associate the disk file with the File object
 File InputFile=new File(GetInputFile());
 // Now, open a stream from the input file
 BufferedReader DataInput=
                         new BufferedReader(new FileReader(InputFile));
 File OutputFile=new File("sums.dat");
 PrintStream DataOutput=
                      new PrintStream(new FileOutputStream(OutputFile));
 // Read the file and process it
 String Line,OutStr;
 while ((Line=DataInput.readLine())!=null) {
  SumOfLine=SumLine(Line);
  OutStr=String.valueOf(SumOfLine);
  DataOutput.print(OutStr+"\n");
  SumOfFile+=SumOfLine;
 }
 OutStr=String.valueOf(SumOfFile);
 DataOutput.print(OutStr+"\n");
}


}

